unordered_set.h
Go to the documentation of this file.
// unordered_set implementation -*- C++ -*-
// Copyright (C) 2010-2016 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library. This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// Under Section 7 of GPL version 3, you are granted additional
// permissions described in the GCC Runtime Library Exception, version
// 3.1, as published by the Free Software Foundation.
// You should have received a copy of the GNU General Public License and
// a copy of the GCC Runtime Library Exception along with this program;
// see the files COPYING3 and COPYING.RUNTIME respectively. If not, see
// <http://www.gnu.org/licenses/>.
/** @file bits/unordered_set.h
* This is an internal header file, included by other library headers.
* Do not attempt to use it directly. @headername{unordered_set}
*/
#ifndef _UNORDERED_SET_H
#define _UNORDERED_SET_H
namespace std _GLIBCXX_VISIBILITY(default)
{
_GLIBCXX_BEGIN_NAMESPACE_CONTAINER
/// Base types for unordered_set.
template<bool _Cache>
using __uset_traits = __detail::_Hashtable_traits<_Cache, true, true>;
template<typename _Value,
typename _Hash = hash<_Value>,
typename _Pred = std::equal_to<_Value>,
typename _Alloc = std::allocator<_Value>,
typename _Tr = __uset_traits<__cache_default<_Value, _Hash>::value>>
using __uset_hashtable = _Hashtable<_Value, _Value, _Alloc,
__detail::_Identity, _Pred, _Hash,
__detail::_Mod_range_hashing,
__detail::_Default_ranged_hash,
__detail::_Prime_rehash_policy, _Tr>;
/// Base types for unordered_multiset.
template<bool _Cache>
using __umset_traits = __detail::_Hashtable_traits<_Cache, true, false>;
template<typename _Value,
typename _Hash = hash<_Value>,
typename _Pred = std::equal_to<_Value>,
typename _Alloc = std::allocator<_Value>,
typename _Tr = __umset_traits<__cache_default<_Value, _Hash>::value>>
using __umset_hashtable = _Hashtable<_Value, _Value, _Alloc,
__detail::_Identity,
_Pred, _Hash,
__detail::_Mod_range_hashing,
__detail::_Default_ranged_hash,
__detail::_Prime_rehash_policy, _Tr>;
/**
* @brief A standard container composed of unique keys (containing
* at most one of each key value) in which the elements' keys are
* the elements themselves.
*
* @ingroup unordered_associative_containers
*
* @tparam _Value Type of key objects.
* @tparam _Hash Hashing function object type, defaults to hash<_Value>.
* @tparam _Pred Predicate function object type, defaults to
* equal_to<_Value>.
*
* @tparam _Alloc Allocator type, defaults to allocator<_Key>.
*
* Meets the requirements of a <a href="tables.html#65">container</a>, and
* <a href="tables.html#xx">unordered associative container</a>
*
* Base is _Hashtable, dispatched at compile time via template
* alias __uset_hashtable.
*/
template<class _Value,
class _Hash = hash<_Value>,
class _Pred = std::equal_to<_Value>,
class _Alloc = std::allocator<_Value> >
class unordered_set
{
typedef __uset_hashtable<_Value, _Hash, _Pred, _Alloc> _Hashtable;
_Hashtable _M_h;
public:
// typedefs:
//@{
/// Public typedefs.
typedef typename _Hashtable::key_type key_type;
typedef typename _Hashtable::value_type value_type;
typedef typename _Hashtable::hasher hasher;
typedef typename _Hashtable::key_equal key_equal;
typedef typename _Hashtable::allocator_type allocator_type;
//@}
//@{
/// Iterator-related typedefs.
typedef typename _Hashtable::pointer pointer;
typedef typename _Hashtable::const_pointer const_pointer;
typedef typename _Hashtable::reference reference;
typedef typename _Hashtable::const_reference const_reference;
typedef typename _Hashtable::iterator iterator;
typedef typename _Hashtable::const_iterator const_iterator;
typedef typename _Hashtable::local_iterator local_iterator;
typedef typename _Hashtable::const_local_iterator const_local_iterator;
typedef typename _Hashtable::size_type size_type;
typedef typename _Hashtable::difference_type difference_type;
//@}
// construct/destroy/copy
/// Default constructor.
unordered_set() = default;
/**
* @brief Default constructor creates no elements.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*/
explicit
unordered_set(size_type __n,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__n, __hf, __eql, __a)
{ }
/**
* @brief Builds an %unordered_set from a range.
* @param __first An input iterator.
* @param __last An input iterator.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*
* Create an %unordered_set consisting of copies of the elements from
* [__first,__last). This is linear in N (where N is
* distance(__first,__last)).
*/
template<typename _InputIterator>
unordered_set(_InputIterator __first, _InputIterator __last,
size_type __n = 0,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__first, __last, __n, __hf, __eql, __a)
{ }
/// Copy constructor.
unordered_set(const unordered_set&) = default;
/// Move constructor.
unordered_set(unordered_set&&) = default;
/**
* @brief Creates an %unordered_set with no elements.
* @param __a An allocator object.
*/
explicit
unordered_set(const allocator_type& __a)
: _M_h(__a)
{ }
/*
* @brief Copy constructor with allocator argument.
* @param __uset Input %unordered_set to copy.
* @param __a An allocator object.
*/
unordered_set(const unordered_set& __uset,
const allocator_type& __a)
: _M_h(__uset._M_h, __a)
{ }
/*
* @brief Move constructor with allocator argument.
* @param __uset Input %unordered_set to move.
* @param __a An allocator object.
*/
unordered_set(unordered_set&& __uset,
const allocator_type& __a)
: _M_h(std::move(__uset._M_h), __a)
{ }
/**
* @brief Builds an %unordered_set from an initializer_list.
* @param __l An initializer_list.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*
* Create an %unordered_set consisting of copies of the elements in the
* list. This is linear in N (where N is @a __l.size()).
*/
unordered_set(initializer_list<value_type> __l,
size_type __n = 0,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__l, __n, __hf, __eql, __a)
{ }
unordered_set(size_type __n, const allocator_type& __a)
: unordered_set(__n, hasher(), key_equal(), __a)
{ }
unordered_set(size_type __n, const hasher& __hf,
const allocator_type& __a)
: unordered_set(__n, __hf, key_equal(), __a)
{ }
template<typename _InputIterator>
unordered_set(_InputIterator __first, _InputIterator __last,
size_type __n,
const allocator_type& __a)
: unordered_set(__first, __last, __n, hasher(), key_equal(), __a)
{ }
template<typename _InputIterator>
unordered_set(_InputIterator __first, _InputIterator __last,
size_type __n, const hasher& __hf,
const allocator_type& __a)
: unordered_set(__first, __last, __n, __hf, key_equal(), __a)
{ }
unordered_set(initializer_list<value_type> __l,
size_type __n,
const allocator_type& __a)
: unordered_set(__l, __n, hasher(), key_equal(), __a)
{ }
unordered_set(initializer_list<value_type> __l,
size_type __n, const hasher& __hf,
const allocator_type& __a)
: unordered_set(__l, __n, __hf, key_equal(), __a)
{ }
/// Copy assignment operator.
unordered_set&
operator=(const unordered_set&) = default;
/// Move assignment operator.
unordered_set&
operator=(unordered_set&&) = default;
/**
* @brief %Unordered_set list assignment operator.
* @param __l An initializer_list.
*
* This function fills an %unordered_set with copies of the elements in
* the initializer list @a __l.
*
* Note that the assignment completely changes the %unordered_set and
* that the resulting %unordered_set's size is the same as the number
* of elements assigned. Old data may be lost.
*/
unordered_set&
operator=(initializer_list<value_type> __l)
{
_M_h = __l;
return *this;
}
/// Returns the allocator object with which the %unordered_set was
/// constructed.
allocator_type
get_allocator() const noexcept
{ return _M_h.get_allocator(); }
// size and capacity:
/// Returns true if the %unordered_set is empty.
bool
empty() const noexcept
{ return _M_h.empty(); }
/// Returns the size of the %unordered_set.
size_type
size() const noexcept
{ return _M_h.size(); }
/// Returns the maximum size of the %unordered_set.
size_type
max_size() const noexcept
{ return _M_h.max_size(); }
// iterators.
//@{
/**
* Returns a read-only (constant) iterator that points to the first
* element in the %unordered_set.
*/
iterator
begin() noexcept
{ return _M_h.begin(); }
const_iterator
begin() const noexcept
{ return _M_h.begin(); }
//@}
//@{
/**
* Returns a read-only (constant) iterator that points one past the last
* element in the %unordered_set.
*/
iterator
end() noexcept
{ return _M_h.end(); }
const_iterator
end() const noexcept
{ return _M_h.end(); }
//@}
/**
* Returns a read-only (constant) iterator that points to the first
* element in the %unordered_set.
*/
const_iterator
cbegin() const noexcept
{ return _M_h.begin(); }
/**
* Returns a read-only (constant) iterator that points one past the last
* element in the %unordered_set.
*/
const_iterator
cend() const noexcept
{ return _M_h.end(); }
// modifiers.
/**
* @brief Attempts to build and insert an element into the
* %unordered_set.
* @param __args Arguments used to generate an element.
* @return A pair, of which the first element is an iterator that points
* to the possibly inserted element, and the second is a bool
* that is true if the element was actually inserted.
*
* This function attempts to build and insert an element into the
* %unordered_set. An %unordered_set relies on unique keys and thus an
* element is only inserted if it is not already present in the
* %unordered_set.
*
* Insertion requires amortized constant time.
*/
template<typename... _Args>
std::pair<iterator, bool>
emplace(_Args&&... __args)
{ return _M_h.emplace(std::forward<_Args>(__args)...); }
/**
* @brief Attempts to insert an element into the %unordered_set.
* @param __pos An iterator that serves as a hint as to where the
* element should be inserted.
* @param __args Arguments used to generate the element to be
* inserted.
* @return An iterator that points to the element with key equivalent to
* the one generated from @a __args (may or may not be the
* element itself).
*
* This function is not concerned about whether the insertion took place,
* and thus does not return a boolean like the single-argument emplace()
* does. Note that the first parameter is only a hint and can
* potentially improve the performance of the insertion process. A bad
* hint would cause no gains in efficiency.
*
* For more on @a hinting, see:
* https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints
*
* Insertion requires amortized constant time.
*/
template<typename... _Args>
iterator
emplace_hint(const_iterator __pos, _Args&&... __args)
{ return _M_h.emplace_hint(__pos, std::forward<_Args>(__args)...); }
//@{
/**
* @brief Attempts to insert an element into the %unordered_set.
* @param __x Element to be inserted.
* @return A pair, of which the first element is an iterator that points
* to the possibly inserted element, and the second is a bool
* that is true if the element was actually inserted.
*
* This function attempts to insert an element into the %unordered_set.
* An %unordered_set relies on unique keys and thus an element is only
* inserted if it is not already present in the %unordered_set.
*
* Insertion requires amortized constant time.
*/
std::pair<iterator, bool>
insert(const value_type& __x)
{ return _M_h.insert(__x); }
std::pair<iterator, bool>
insert(value_type&& __x)
{ return _M_h.insert(std::move(__x)); }
//@}
//@{
/**
* @brief Attempts to insert an element into the %unordered_set.
* @param __hint An iterator that serves as a hint as to where the
* element should be inserted.
* @param __x Element to be inserted.
* @return An iterator that points to the element with key of
* @a __x (may or may not be the element passed in).
*
* This function is not concerned about whether the insertion took place,
* and thus does not return a boolean like the single-argument insert()
* does. Note that the first parameter is only a hint and can
* potentially improve the performance of the insertion process. A bad
* hint would cause no gains in efficiency.
*
* For more on @a hinting, see:
* https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints
*
* Insertion requires amortized constant.
*/
iterator
insert(const_iterator __hint, const value_type& __x)
{ return _M_h.insert(__hint, __x); }
iterator
insert(const_iterator __hint, value_type&& __x)
{ return _M_h.insert(__hint, std::move(__x)); }
//@}
/**
* @brief A template function that attempts to insert a range of
* elements.
* @param __first Iterator pointing to the start of the range to be
* inserted.
* @param __last Iterator pointing to the end of the range.
*
* Complexity similar to that of the range constructor.
*/
template<typename _InputIterator>
void
insert(_InputIterator __first, _InputIterator __last)
{ _M_h.insert(__first, __last); }
/**
* @brief Attempts to insert a list of elements into the %unordered_set.
* @param __l A std::initializer_list<value_type> of elements
* to be inserted.
*
* Complexity similar to that of the range constructor.
*/
void
insert(initializer_list<value_type> __l)
{ _M_h.insert(__l); }
//@{
/**
* @brief Erases an element from an %unordered_set.
* @param __position An iterator pointing to the element to be erased.
* @return An iterator pointing to the element immediately following
* @a __position prior to the element being erased. If no such
* element exists, end() is returned.
*
* This function erases an element, pointed to by the given iterator,
* from an %unordered_set. Note that this function only erases the
* element, and that if the element is itself a pointer, the pointed-to
* memory is not touched in any way. Managing the pointer is the user's
* responsibility.
*/
iterator
erase(const_iterator __position)
{ return _M_h.erase(__position); }
// LWG 2059.
iterator
erase(iterator __position)
{ return _M_h.erase(__position); }
//@}
/**
* @brief Erases elements according to the provided key.
* @param __x Key of element to be erased.
* @return The number of elements erased.
*
* This function erases all the elements located by the given key from
* an %unordered_set. For an %unordered_set the result of this function
* can only be 0 (not present) or 1 (present).
* Note that this function only erases the element, and that if
* the element is itself a pointer, the pointed-to memory is not touched
* in any way. Managing the pointer is the user's responsibility.
*/
size_type
erase(const key_type& __x)
{ return _M_h.erase(__x); }
/**
* @brief Erases a [__first,__last) range of elements from an
* %unordered_set.
* @param __first Iterator pointing to the start of the range to be
* erased.
* @param __last Iterator pointing to the end of the range to
* be erased.
* @return The iterator @a __last.
*
* This function erases a sequence of elements from an %unordered_set.
* Note that this function only erases the element, and that if
* the element is itself a pointer, the pointed-to memory is not touched
* in any way. Managing the pointer is the user's responsibility.
*/
iterator
erase(const_iterator __first, const_iterator __last)
{ return _M_h.erase(__first, __last); }
/**
* Erases all elements in an %unordered_set. Note that this function only
* erases the elements, and that if the elements themselves are pointers,
* the pointed-to memory is not touched in any way. Managing the pointer
* is the user's responsibility.
*/
void
clear() noexcept
{ _M_h.clear(); }
/**
* @brief Swaps data with another %unordered_set.
* @param __x An %unordered_set of the same element and allocator
* types.
*
* This exchanges the elements between two sets in constant time.
* Note that the global std::swap() function is specialized such that
* std::swap(s1,s2) will feed to this function.
*/
void
swap(unordered_set& __x)
noexcept( noexcept(_M_h.swap(__x._M_h)) )
{ _M_h.swap(__x._M_h); }
// observers.
/// Returns the hash functor object with which the %unordered_set was
/// constructed.
hasher
hash_function() const
{ return _M_h.hash_function(); }
/// Returns the key comparison object with which the %unordered_set was
/// constructed.
key_equal
key_eq() const
{ return _M_h.key_eq(); }
// lookup.
//@{
/**
* @brief Tries to locate an element in an %unordered_set.
* @param __x Element to be located.
* @return Iterator pointing to sought-after element, or end() if not
* found.
*
* This function takes a key and tries to locate the element with which
* the key matches. If successful the function returns an iterator
* pointing to the sought after element. If unsuccessful it returns the
* past-the-end ( @c end() ) iterator.
*/
iterator
find(const key_type& __x)
{ return _M_h.find(__x); }
const_iterator
find(const key_type& __x) const
{ return _M_h.find(__x); }
//@}
/**
* @brief Finds the number of elements.
* @param __x Element to located.
* @return Number of elements with specified key.
*
* This function only makes sense for unordered_multisets; for
* unordered_set the result will either be 0 (not present) or 1
* (present).
*/
size_type
count(const key_type& __x) const
{ return _M_h.count(__x); }
//@{
/**
* @brief Finds a subsequence matching given key.
* @param __x Key to be located.
* @return Pair of iterators that possibly points to the subsequence
* matching given key.
*
* This function probably only makes sense for multisets.
*/
std::pair<iterator, iterator>
equal_range(const key_type& __x)
{ return _M_h.equal_range(__x); }
std::pair<const_iterator, const_iterator>
equal_range(const key_type& __x) const
{ return _M_h.equal_range(__x); }
//@}
// bucket interface.
/// Returns the number of buckets of the %unordered_set.
size_type
bucket_count() const noexcept
{ return _M_h.bucket_count(); }
/// Returns the maximum number of buckets of the %unordered_set.
size_type
max_bucket_count() const noexcept
{ return _M_h.max_bucket_count(); }
/*
* @brief Returns the number of elements in a given bucket.
* @param __n A bucket index.
* @return The number of elements in the bucket.
*/
size_type
bucket_size(size_type __n) const
{ return _M_h.bucket_size(__n); }
/*
* @brief Returns the bucket index of a given element.
* @param __key A key instance.
* @return The key bucket index.
*/
size_type
bucket(const key_type& __key) const
{ return _M_h.bucket(__key); }
//@{
/**
* @brief Returns a read-only (constant) iterator pointing to the first
* bucket element.
* @param __n The bucket index.
* @return A read-only local iterator.
*/
local_iterator
begin(size_type __n)
{ return _M_h.begin(__n); }
const_local_iterator
begin(size_type __n) const
{ return _M_h.begin(__n); }
const_local_iterator
cbegin(size_type __n) const
{ return _M_h.cbegin(__n); }
//@}
//@{
/**
* @brief Returns a read-only (constant) iterator pointing to one past
* the last bucket elements.
* @param __n The bucket index.
* @return A read-only local iterator.
*/
local_iterator
end(size_type __n)
{ return _M_h.end(__n); }
const_local_iterator
end(size_type __n) const
{ return _M_h.end(__n); }
const_local_iterator
cend(size_type __n) const
{ return _M_h.cend(__n); }
//@}
// hash policy.
/// Returns the average number of elements per bucket.
float
load_factor() const noexcept
{ return _M_h.load_factor(); }
/// Returns a positive number that the %unordered_set tries to keep the
/// load factor less than or equal to.
float
max_load_factor() const noexcept
{ return _M_h.max_load_factor(); }
/**
* @brief Change the %unordered_set maximum load factor.
* @param __z The new maximum load factor.
*/
void
max_load_factor(float __z)
{ _M_h.max_load_factor(__z); }
/**
* @brief May rehash the %unordered_set.
* @param __n The new number of buckets.
*
* Rehash will occur only if the new number of buckets respect the
* %unordered_set maximum load factor.
*/
void
rehash(size_type __n)
{ _M_h.rehash(__n); }
/**
* @brief Prepare the %unordered_set for a specified number of
* elements.
* @param __n Number of elements required.
*
* Same as rehash(ceil(n / max_load_factor())).
*/
void
reserve(size_type __n)
{ _M_h.reserve(__n); }
template<typename _Value1, typename _Hash1, typename _Pred1,
typename _Alloc1>
friend bool
operator==(const unordered_set<_Value1, _Hash1, _Pred1, _Alloc1>&,
const unordered_set<_Value1, _Hash1, _Pred1, _Alloc1>&);
};
/**
* @brief A standard container composed of equivalent keys
* (possibly containing multiple of each key value) in which the
* elements' keys are the elements themselves.
*
* @ingroup unordered_associative_containers
*
* @tparam _Value Type of key objects.
* @tparam _Hash Hashing function object type, defaults to hash<_Value>.
* @tparam _Pred Predicate function object type, defaults
* to equal_to<_Value>.
* @tparam _Alloc Allocator type, defaults to allocator<_Key>.
*
* Meets the requirements of a <a href="tables.html#65">container</a>, and
* <a href="tables.html#xx">unordered associative container</a>
*
* Base is _Hashtable, dispatched at compile time via template
* alias __umset_hashtable.
*/
template<class _Value,
class _Hash = hash<_Value>,
class _Pred = std::equal_to<_Value>,
class _Alloc = std::allocator<_Value> >
class unordered_multiset
{
typedef __umset_hashtable<_Value, _Hash, _Pred, _Alloc> _Hashtable;
_Hashtable _M_h;
public:
// typedefs:
//@{
/// Public typedefs.
typedef typename _Hashtable::key_type key_type;
typedef typename _Hashtable::value_type value_type;
typedef typename _Hashtable::hasher hasher;
typedef typename _Hashtable::key_equal key_equal;
typedef typename _Hashtable::allocator_type allocator_type;
//@}
//@{
/// Iterator-related typedefs.
typedef typename _Hashtable::pointer pointer;
typedef typename _Hashtable::const_pointer const_pointer;
typedef typename _Hashtable::reference reference;
typedef typename _Hashtable::const_reference const_reference;
typedef typename _Hashtable::iterator iterator;
typedef typename _Hashtable::const_iterator const_iterator;
typedef typename _Hashtable::local_iterator local_iterator;
typedef typename _Hashtable::const_local_iterator const_local_iterator;
typedef typename _Hashtable::size_type size_type;
typedef typename _Hashtable::difference_type difference_type;
//@}
// construct/destroy/copy
/// Default constructor.
unordered_multiset() = default;
/**
* @brief Default constructor creates no elements.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*/
explicit
unordered_multiset(size_type __n,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__n, __hf, __eql, __a)
{ }
/**
* @brief Builds an %unordered_multiset from a range.
* @param __first An input iterator.
* @param __last An input iterator.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*
* Create an %unordered_multiset consisting of copies of the elements
* from [__first,__last). This is linear in N (where N is
* distance(__first,__last)).
*/
template<typename _InputIterator>
unordered_multiset(_InputIterator __first, _InputIterator __last,
size_type __n = 0,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__first, __last, __n, __hf, __eql, __a)
{ }
/// Copy constructor.
unordered_multiset(const unordered_multiset&) = default;
/// Move constructor.
unordered_multiset(unordered_multiset&&) = default;
/**
* @brief Builds an %unordered_multiset from an initializer_list.
* @param __l An initializer_list.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*
* Create an %unordered_multiset consisting of copies of the elements in
* the list. This is linear in N (where N is @a __l.size()).
*/
unordered_multiset(initializer_list<value_type> __l,
size_type __n = 0,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__l, __n, __hf, __eql, __a)
{ }
/// Copy assignment operator.
unordered_multiset&
operator=(const unordered_multiset&) = default;
/// Move assignment operator.
unordered_multiset&
operator=(unordered_multiset&&) = default;
/**
* @brief Creates an %unordered_multiset with no elements.
* @param __a An allocator object.
*/
explicit
unordered_multiset(const allocator_type& __a)
: _M_h(__a)
{ }
/*
* @brief Copy constructor with allocator argument.
* @param __uset Input %unordered_multiset to copy.
* @param __a An allocator object.
*/
unordered_multiset(const unordered_multiset& __umset,
const allocator_type& __a)
: _M_h(__umset._M_h, __a)
{ }
/*
* @brief Move constructor with allocator argument.
* @param __umset Input %unordered_multiset to move.
* @param __a An allocator object.
*/
unordered_multiset(unordered_multiset&& __umset,
const allocator_type& __a)
: _M_h(std::move(__umset._M_h), __a)
{ }
unordered_multiset(size_type __n, const allocator_type& __a)
: unordered_multiset(__n, hasher(), key_equal(), __a)
{ }
unordered_multiset(size_type __n, const hasher& __hf,
const allocator_type& __a)
: unordered_multiset(__n, __hf, key_equal(), __a)
{ }
template<typename _InputIterator>
unordered_multiset(_InputIterator __first, _InputIterator __last,
size_type __n,
const allocator_type& __a)
: unordered_multiset(__first, __last, __n, hasher(), key_equal(), __a)
{ }
template<typename _InputIterator>
unordered_multiset(_InputIterator __first, _InputIterator __last,
size_type __n, const hasher& __hf,
const allocator_type& __a)
: unordered_multiset(__first, __last, __n, __hf, key_equal(), __a)
{ }
unordered_multiset(initializer_list<value_type> __l,
size_type __n,
const allocator_type& __a)
: unordered_multiset(__l, __n, hasher(), key_equal(), __a)
{ }
unordered_multiset(initializer_list<value_type> __l,
size_type __n, const hasher& __hf,
const allocator_type& __a)
: unordered_multiset(__l, __n, __hf, key_equal(), __a)
{ }
/**
* @brief %Unordered_multiset list assignment operator.
* @param __l An initializer_list.
*
* This function fills an %unordered_multiset with copies of the elements
* in the initializer list @a __l.
*
* Note that the assignment completely changes the %unordered_multiset
* and that the resulting %unordered_multiset's size is the same as the
* number of elements assigned. Old data may be lost.
*/
unordered_multiset&
operator=(initializer_list<value_type> __l)
{
_M_h = __l;
return *this;
}
/// Returns the allocator object with which the %unordered_multiset was
/// constructed.
allocator_type
get_allocator() const noexcept
{ return _M_h.get_allocator(); }
// size and capacity:
/// Returns true if the %unordered_multiset is empty.
bool
empty() const noexcept
{ return _M_h.empty(); }
/// Returns the size of the %unordered_multiset.
size_type
size() const noexcept
{ return _M_h.size(); }
/// Returns the maximum size of the %unordered_multiset.
size_type
max_size() const noexcept
{ return _M_h.max_size(); }
// iterators.
//@{
/**
* Returns a read-only (constant) iterator that points to the first
* element in the %unordered_multiset.
*/
iterator
begin() noexcept
{ return _M_h.begin(); }
const_iterator
begin() const noexcept
{ return _M_h.begin(); }
//@}
//@{
/**
* Returns a read-only (constant) iterator that points one past the last
* element in the %unordered_multiset.
*/
iterator
end() noexcept
{ return _M_h.end(); }
const_iterator
end() const noexcept
{ return _M_h.end(); }
//@}
/**
* Returns a read-only (constant) iterator that points to the first
* element in the %unordered_multiset.
*/
const_iterator
cbegin() const noexcept
{ return _M_h.begin(); }
/**
* Returns a read-only (constant) iterator that points one past the last
* element in the %unordered_multiset.
*/
const_iterator
cend() const noexcept
{ return _M_h.end(); }
// modifiers.
/**
* @brief Builds and insert an element into the %unordered_multiset.
* @param __args Arguments used to generate an element.
* @return An iterator that points to the inserted element.
*
* Insertion requires amortized constant time.
*/
template<typename... _Args>
iterator
emplace(_Args&&... __args)
{ return _M_h.emplace(std::forward<_Args>(__args)...); }
/**
* @brief Inserts an element into the %unordered_multiset.
* @param __pos An iterator that serves as a hint as to where the
* element should be inserted.
* @param __args Arguments used to generate the element to be
* inserted.
* @return An iterator that points to the inserted element.
*
* Note that the first parameter is only a hint and can potentially
* improve the performance of the insertion process. A bad hint would
* cause no gains in efficiency.
*
* For more on @a hinting, see:
* https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints
*
* Insertion requires amortized constant time.
*/
template<typename... _Args>
iterator
emplace_hint(const_iterator __pos, _Args&&... __args)
{ return _M_h.emplace_hint(__pos, std::forward<_Args>(__args)...); }
//@{
/**
* @brief Inserts an element into the %unordered_multiset.
* @param __x Element to be inserted.
* @return An iterator that points to the inserted element.
*
* Insertion requires amortized constant time.
*/
iterator
insert(const value_type& __x)
{ return _M_h.insert(__x); }
iterator
insert(value_type&& __x)
{ return _M_h.insert(std::move(__x)); }
//@}
//@{
/**
* @brief Inserts an element into the %unordered_multiset.
* @param __hint An iterator that serves as a hint as to where the
* element should be inserted.
* @param __x Element to be inserted.
* @return An iterator that points to the inserted element.
*
* Note that the first parameter is only a hint and can potentially
* improve the performance of the insertion process. A bad hint would
* cause no gains in efficiency.
*
* For more on @a hinting, see:
* https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints
*
* Insertion requires amortized constant.
*/
iterator
insert(const_iterator __hint, const value_type& __x)
{ return _M_h.insert(__hint, __x); }
iterator
insert(const_iterator __hint, value_type&& __x)
{ return _M_h.insert(__hint, std::move(__x)); }
//@}
/**
* @brief A template function that inserts a range of elements.
* @param __first Iterator pointing to the start of the range to be
* inserted.
* @param __last Iterator pointing to the end of the range.
*
* Complexity similar to that of the range constructor.
*/
template<typename _InputIterator>
void
insert(_InputIterator __first, _InputIterator __last)
{ _M_h.insert(__first, __last); }
/**
* @brief Inserts a list of elements into the %unordered_multiset.
* @param __l A std::initializer_list<value_type> of elements to be
* inserted.
*
* Complexity similar to that of the range constructor.
*/
void
insert(initializer_list<value_type> __l)
{ _M_h.insert(__l); }
//@{
/**
* @brief Erases an element from an %unordered_multiset.
* @param __position An iterator pointing to the element to be erased.
* @return An iterator pointing to the element immediately following
* @a __position prior to the element being erased. If no such
* element exists, end() is returned.
*
* This function erases an element, pointed to by the given iterator,
* from an %unordered_multiset.
*
* Note that this function only erases the element, and that if the
* element is itself a pointer, the pointed-to memory is not touched in
* any way. Managing the pointer is the user's responsibility.
*/
iterator
erase(const_iterator __position)
{ return _M_h.erase(__position); }
// LWG 2059.
iterator
erase(iterator __position)
{ return _M_h.erase(__position); }
//@}
/**
* @brief Erases elements according to the provided key.
* @param __x Key of element to be erased.
* @return The number of elements erased.
*
* This function erases all the elements located by the given key from
* an %unordered_multiset.
*
* Note that this function only erases the element, and that if the
* element is itself a pointer, the pointed-to memory is not touched in
* any way. Managing the pointer is the user's responsibility.
*/
size_type
erase(const key_type& __x)
{ return _M_h.erase(__x); }
/**
* @brief Erases a [__first,__last) range of elements from an
* %unordered_multiset.
* @param __first Iterator pointing to the start of the range to be
* erased.
* @param __last Iterator pointing to the end of the range to
* be erased.
* @return The iterator @a __last.
*
* This function erases a sequence of elements from an
* %unordered_multiset.
*
* Note that this function only erases the element, and that if
* the element is itself a pointer, the pointed-to memory is not touched
* in any way. Managing the pointer is the user's responsibility.
*/
iterator
erase(const_iterator __first, const_iterator __last)
{ return _M_h.erase(__first, __last); }
/**
* Erases all elements in an %unordered_multiset.
*
* Note that this function only erases the elements, and that if the
* elements themselves are pointers, the pointed-to memory is not touched
* in any way. Managing the pointer is the user's responsibility.
*/
void
clear() noexcept
{ _M_h.clear(); }
/**
* @brief Swaps data with another %unordered_multiset.
* @param __x An %unordered_multiset of the same element and allocator
* types.
*
* This exchanges the elements between two sets in constant time.
* Note that the global std::swap() function is specialized such that
* std::swap(s1,s2) will feed to this function.
*/
void
swap(unordered_multiset& __x)
noexcept( noexcept(_M_h.swap(__x._M_h)) )
{ _M_h.swap(__x._M_h); }
// observers.
/// Returns the hash functor object with which the %unordered_multiset
/// was constructed.
hasher
hash_function() const
{ return _M_h.hash_function(); }
/// Returns the key comparison object with which the %unordered_multiset
/// was constructed.
key_equal
key_eq() const
{ return _M_h.key_eq(); }
// lookup.
//@{
/**
* @brief Tries to locate an element in an %unordered_multiset.
* @param __x Element to be located.
* @return Iterator pointing to sought-after element, or end() if not
* found.
*
* This function takes a key and tries to locate the element with which
* the key matches. If successful the function returns an iterator
* pointing to the sought after element. If unsuccessful it returns the
* past-the-end ( @c end() ) iterator.
*/
iterator
find(const key_type& __x)
{ return _M_h.find(__x); }
const_iterator
find(const key_type& __x) const
{ return _M_h.find(__x); }
//@}
/**
* @brief Finds the number of elements.
* @param __x Element to located.
* @return Number of elements with specified key.
*/
size_type
count(const key_type& __x) const
{ return _M_h.count(__x); }
//@{
/**
* @brief Finds a subsequence matching given key.
* @param __x Key to be located.
* @return Pair of iterators that possibly points to the subsequence
* matching given key.
*/
std::pair<iterator, iterator>
equal_range(const key_type& __x)
{ return _M_h.equal_range(__x); }
std::pair<const_iterator, const_iterator>
equal_range(const key_type& __x) const
{ return _M_h.equal_range(__x); }
//@}
// bucket interface.
/// Returns the number of buckets of the %unordered_multiset.
size_type
bucket_count() const noexcept
{ return _M_h.bucket_count(); }
/// Returns the maximum number of buckets of the %unordered_multiset.
size_type
max_bucket_count() const noexcept
{ return _M_h.max_bucket_count(); }
/*
* @brief Returns the number of elements in a given bucket.
* @param __n A bucket index.
* @return The number of elements in the bucket.
*/
size_type
bucket_size(size_type __n) const
{ return _M_h.bucket_size(__n); }
/*
* @brief Returns the bucket index of a given element.
* @param __key A key instance.
* @return The key bucket index.
*/
size_type
bucket(const key_type& __key) const
{ return _M_h.bucket(__key); }
//@{
/**
* @brief Returns a read-only (constant) iterator pointing to the first
* bucket element.
* @param __n The bucket index.
* @return A read-only local iterator.
*/
local_iterator
begin(size_type __n)
{ return _M_h.begin(__n); }
const_local_iterator
begin(size_type __n) const
{ return _M_h.begin(__n); }
const_local_iterator
cbegin(size_type __n) const
{ return _M_h.cbegin(__n); }
//@}
//@{
/**
* @brief Returns a read-only (constant) iterator pointing to one past
* the last bucket elements.
* @param __n The bucket index.
* @return A read-only local iterator.
*/
local_iterator
end(size_type __n)
{ return _M_h.end(__n); }
const_local_iterator
end(size_type __n) const
{ return _M_h.end(__n); }
const_local_iterator
cend(size_type __n) const
{ return _M_h.cend(__n); }
//@}
// hash policy.
/// Returns the average number of elements per bucket.
float
load_factor() const noexcept
{ return _M_h.load_factor(); }
/// Returns a positive number that the %unordered_multiset tries to keep the
/// load factor less than or equal to.
float
max_load_factor() const noexcept
{ return _M_h.max_load_factor(); }
/**
* @brief Change the %unordered_multiset maximum load factor.
* @param __z The new maximum load factor.
*/
void
max_load_factor(float __z)
{ _M_h.max_load_factor(__z); }
/**
* @brief May rehash the %unordered_multiset.
* @param __n The new number of buckets.
*
* Rehash will occur only if the new number of buckets respect the
* %unordered_multiset maximum load factor.
*/
void
rehash(size_type __n)
{ _M_h.rehash(__n); }
/**
* @brief Prepare the %unordered_multiset for a specified number of
* elements.
* @param __n Number of elements required.
*
* Same as rehash(ceil(n / max_load_factor())).
*/
void
reserve(size_type __n)
{ _M_h.reserve(__n); }
template<typename _Value1, typename _Hash1, typename _Pred1,
typename _Alloc1>
friend bool
operator==(const unordered_multiset<_Value1, _Hash1, _Pred1, _Alloc1>&,
const unordered_multiset<_Value1, _Hash1, _Pred1, _Alloc1>&);
};
template<class _Value, class _Hash, class _Pred, class _Alloc>
inline void
swap(unordered_set<_Value, _Hash, _Pred, _Alloc>& __x,
unordered_set<_Value, _Hash, _Pred, _Alloc>& __y)
noexcept(noexcept(__x.swap(__y)))
{ __x.swap(__y); }
template<class _Value, class _Hash, class _Pred, class _Alloc>
inline void
swap(unordered_multiset<_Value, _Hash, _Pred, _Alloc>& __x,
unordered_multiset<_Value, _Hash, _Pred, _Alloc>& __y)
noexcept(noexcept(__x.swap(__y)))
{ __x.swap(__y); }
template<class _Value, class _Hash, class _Pred, class _Alloc>
inline bool
operator==(const unordered_set<_Value, _Hash, _Pred, _Alloc>& __x,
const unordered_set<_Value, _Hash, _Pred, _Alloc>& __y)
{ return __x._M_h._M_equal(__y._M_h); }
template<class _Value, class _Hash, class _Pred, class _Alloc>
inline bool
operator!=(const unordered_set<_Value, _Hash, _Pred, _Alloc>& __x,
const unordered_set<_Value, _Hash, _Pred, _Alloc>& __y)
{ return !(__x == __y); }
template<class _Value, class _Hash, class _Pred, class _Alloc>
inline bool
operator==(const unordered_multiset<_Value, _Hash, _Pred, _Alloc>& __x,
const unordered_multiset<_Value, _Hash, _Pred, _Alloc>& __y)
{ return __x._M_h._M_equal(__y._M_h); }
template<class _Value, class _Hash, class _Pred, class _Alloc>
inline bool
operator!=(const unordered_multiset<_Value, _Hash, _Pred, _Alloc>& __x,
const unordered_multiset<_Value, _Hash, _Pred, _Alloc>& __y)
{ return !(__x == __y); }
_GLIBCXX_END_NAMESPACE_CONTAINER
} // namespace std
#endif /* _UNORDERED_SET_H */
std::unordered_multiset::max_bucket_count
size_type max_bucket_count() const noexcept
Returns the maximum number of buckets of the unordered_multiset.
Definition: unordered_set.h:1284
std::unordered_multiset::max_load_factor
float max_load_factor() const noexcept
Returns a positive number that the unordered_multiset tries to keep the load factor less than or equa...
Definition: unordered_set.h:1355
std::__detail::_Prime_rehash_policy
Default value for rehash policy. Bucket size is (usually) the smallest prime that keeps the load fact...
Definition: hashtable_policy.h:458
std::unordered_multiset::unordered_multiset
unordered_multiset(const allocator_type &__a)
Creates an unordered_multiset with no elements.
Definition: unordered_set.h:877
std::unordered_multiset::key_equal
_Hashtable::key_equal key_equal
Public typedefs.
Definition: unordered_set.h:779
std::unordered_set::value_type
_Hashtable::value_type value_type
Public typedefs.
Definition: unordered_set.h:103
std::unordered_multiset::load_factor
float load_factor() const noexcept
Returns the average number of elements per bucket.
Definition: unordered_set.h:1349
std::unordered_set::key_eq
key_equal key_eq() const
Returns the key comparison object with which the unordered_set was constructed.
Definition: unordered_set.h:567
std::unordered_set::cend
const_iterator cend() const noexcept
Definition: unordered_set.h:346
std::unordered_set::cbegin
const_iterator cbegin() const noexcept
Definition: unordered_set.h:338
std::unordered_multiset::end
iterator end() noexcept
Definition: unordered_set.h:999
std::unordered_multiset::end
const_iterator end() const noexcept
Definition: unordered_set.h:1003
std::unordered_set::erase
iterator erase(const_iterator __position)
Erases an element from an unordered_set.
Definition: unordered_set.h:489
std::allocator
The standard allocator, as per [20.4].
Definition: allocator.h:108
std::unordered_set::insert
iterator insert(const_iterator __hint, value_type &&__x)
Attempts to insert an element into the unordered_set.
Definition: unordered_set.h:445
std::unordered_multiset::erase
iterator erase(const_iterator __position)
Erases an element from an unordered_multiset.
Definition: unordered_set.h:1142
std::unordered_set::reserve
void reserve(size_type __n)
Prepare the unordered_set for a specified number of elements.
Definition: unordered_set.h:734
std::unordered_multiset::get_allocator
allocator_type get_allocator() const noexcept
Returns the allocator object with which the unordered_multiset was constructed.
Definition: unordered_set.h:957
std::initializer_list
initializer_list
Definition: initializer_list:47
std::unordered_set::unordered_set
unordered_set()=default
Default constructor.
std::unordered_set::const_local_iterator
_Hashtable::const_local_iterator const_local_iterator
Iterator-related typedefs.
Definition: unordered_set.h:118
std::unordered_set::iterator
_Hashtable::iterator iterator
Iterator-related typedefs.
Definition: unordered_set.h:115
std::unordered_multiset::cend
const_iterator cend() const noexcept
Definition: unordered_set.h:1020
std::unordered_multiset::unordered_multiset
unordered_multiset(initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_multiset from an initializer_list.
Definition: unordered_set.h:856
std::unordered_set::key_type
_Hashtable::key_type key_type
Public typedefs.
Definition: unordered_set.h:102
std::unordered_multiset::const_pointer
_Hashtable::const_pointer const_pointer
Iterator-related typedefs.
Definition: unordered_set.h:786
std::unordered_multiset::allocator_type
_Hashtable::allocator_type allocator_type
Public typedefs.
Definition: unordered_set.h:780
std::unordered_multiset::equal_range
std::pair< iterator, iterator > equal_range(const key_type &__x)
Finds a subsequence matching given key.
Definition: unordered_set.h:1267
std::unordered_set::reference
_Hashtable::reference reference
Iterator-related typedefs.
Definition: unordered_set.h:113
std::unordered_multiset::clear
void clear() noexcept
Definition: unordered_set.h:1196
std::unordered_set::difference_type
_Hashtable::difference_type difference_type
Iterator-related typedefs.
Definition: unordered_set.h:120
std::unordered_set::erase
iterator erase(iterator __position)
Erases an element from an unordered_set.
Definition: unordered_set.h:494
std::unordered_multiset::begin
const_iterator begin() const noexcept
Definition: unordered_set.h:989
std::unordered_multiset::cbegin
const_iterator cbegin() const noexcept
Definition: unordered_set.h:1012
std::unordered_set::unordered_set
unordered_set(initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_set from an initializer_list.
Definition: unordered_set.h:211
std::unordered_set::const_reference
_Hashtable::const_reference const_reference
Iterator-related typedefs.
Definition: unordered_set.h:114
std::unordered_multiset::count
size_type count(const key_type &__x) const
Finds the number of elements.
Definition: unordered_set.h:1256
std::unordered_multiset::unordered_multiset
unordered_multiset(size_type __n, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Default constructor creates no elements.
Definition: unordered_set.h:810
std::unordered_set::max_bucket_count
size_type max_bucket_count() const noexcept
Returns the maximum number of buckets of the unordered_set.
Definition: unordered_set.h:633
std::unordered_multiset::insert
iterator insert(const_iterator __hint, const value_type &__x)
Inserts an element into the unordered_multiset.
Definition: unordered_set.h:1094
std::unordered_set::count
size_type count(const key_type &__x) const
Finds the number of elements.
Definition: unordered_set.h:603
std::unordered_multiset::begin
iterator begin() noexcept
Definition: unordered_set.h:985
std::unordered_multiset::emplace
iterator emplace(_Args &&... __args)
Builds and insert an element into the unordered_multiset.
Definition: unordered_set.h:1034
std::unordered_multiset::pointer
_Hashtable::pointer pointer
Iterator-related typedefs.
Definition: unordered_set.h:785
std::unordered_multiset::value_type
_Hashtable::value_type value_type
Public typedefs.
Definition: unordered_set.h:777
std::unordered_multiset::cend
const_local_iterator cend(size_type __n) const
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_set.h:1341
std::unordered_multiset::reference
_Hashtable::reference reference
Iterator-related typedefs.
Definition: unordered_set.h:787
std::unordered_set::max_load_factor
void max_load_factor(float __z)
Change the unordered_set maximum load factor.
Definition: unordered_set.h:712
std::unordered_set::allocator_type
_Hashtable::allocator_type allocator_type
Public typedefs.
Definition: unordered_set.h:106
std::unordered_set::size_type
_Hashtable::size_type size_type
Iterator-related typedefs.
Definition: unordered_set.h:119
std::unordered_set::begin
const_local_iterator begin(size_type __n) const
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_set.h:666
std::unordered_set::clear
void clear() noexcept
Definition: unordered_set.h:539
std::unordered_set::find
const_iterator find(const key_type &__x) const
Tries to locate an element in an unordered_set.
Definition: unordered_set.h:589
std::unordered_set::end
iterator end() noexcept
Definition: unordered_set.h:325
std::unordered_multiset::begin
const_local_iterator begin(size_type __n) const
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_set.h:1317
std::unordered_set::local_iterator
_Hashtable::local_iterator local_iterator
Iterator-related typedefs.
Definition: unordered_set.h:117
std::unordered_multiset::local_iterator
_Hashtable::local_iterator local_iterator
Iterator-related typedefs.
Definition: unordered_set.h:791
std::unordered_set::insert
std::pair< iterator, bool > insert(const value_type &__x)
Attempts to insert an element into the unordered_set.
Definition: unordered_set.h:412
std::unordered_multiset::end
const_local_iterator end(size_type __n) const
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_set.h:1337
std::unordered_multiset::equal_range
std::pair< const_iterator, const_iterator > equal_range(const key_type &__x) const
Finds a subsequence matching given key.
Definition: unordered_set.h:1271
std::unordered_multiset::size_type
_Hashtable::size_type size_type
Iterator-related typedefs.
Definition: unordered_set.h:793
std::unordered_set::const_pointer
_Hashtable::const_pointer const_pointer
Iterator-related typedefs.
Definition: unordered_set.h:112
std::unordered_set::pointer
_Hashtable::pointer pointer
Iterator-related typedefs.
Definition: unordered_set.h:111
std::unordered_multiset::find
const_iterator find(const key_type &__x) const
Tries to locate an element in an unordered_multiset.
Definition: unordered_set.h:1246
std::unordered_set::unordered_set
unordered_set(const allocator_type &__a)
Creates an unordered_set with no elements.
Definition: unordered_set.h:176
std::__detail::_Hashtable_traits
Definition: hashtable_policy.h:212
std::_Hashtable
Definition: bits/hashtable.h:170
std::unordered_set::unordered_set
unordered_set(size_type __n, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Default constructor creates no elements.
Definition: unordered_set.h:136
std::unordered_multiset::key_eq
key_equal key_eq() const
Returns the key comparison object with which the unordered_multiset was constructed.
Definition: unordered_set.h:1224
std::unordered_multiset::cbegin
const_local_iterator cbegin(size_type __n) const
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_set.h:1321
std::unordered_multiset::begin
local_iterator begin(size_type __n)
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_set.h:1313
std::unordered_multiset::unordered_multiset
unordered_multiset(_InputIterator __first, _InputIterator __last, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_multiset from a range.
Definition: unordered_set.h:831
std::unordered_set::load_factor
float load_factor() const noexcept
Returns the average number of elements per bucket.
Definition: unordered_set.h:698
std::unordered_set::const_iterator
_Hashtable::const_iterator const_iterator
Iterator-related typedefs.
Definition: unordered_set.h:116
std::unordered_set::erase
iterator erase(const_iterator __first, const_iterator __last)
Erases a [__first,__last) range of elements from an unordered_set.
Definition: unordered_set.h:529
std::unordered_set::end
const_local_iterator end(size_type __n) const
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_set.h:686
std::unordered_multiset::insert
iterator insert(value_type &&__x)
Inserts an element into the unordered_multiset.
Definition: unordered_set.h:1072
std::unordered_set::get_allocator
allocator_type get_allocator() const noexcept
Returns the allocator object with which the unordered_set was constructed.
Definition: unordered_set.h:283
std::unordered_set::key_equal
_Hashtable::key_equal key_equal
Public typedefs.
Definition: unordered_set.h:105
std::unordered_multiset::empty
bool empty() const noexcept
Returns true if the unordered_multiset is empty.
Definition: unordered_set.h:964
std::equal_to
One of the comparison functors.
Definition: stl_function.h:331
std::unordered_set::max_size
size_type max_size() const noexcept
Returns the maximum size of the unordered_set.
Definition: unordered_set.h:300
std::unordered_set::insert
void insert(_InputIterator __first, _InputIterator __last)
A template function that attempts to insert a range of elements.
Definition: unordered_set.h:460
std::unordered_set::size
size_type size() const noexcept
Returns the size of the unordered_set.
Definition: unordered_set.h:295
std::unordered_multiset::reserve
void reserve(size_type __n)
Prepare the unordered_multiset for a specified number of elements.
Definition: unordered_set.h:1385
std::unordered_set::max_load_factor
float max_load_factor() const noexcept
Returns a positive number that the unordered_set tries to keep the load factor less than or equal to...
Definition: unordered_set.h:704
std::__detail::_Default_ranged_hash
Default ranged hash function H. In principle it should be a function object composed from objects of ...
Definition: hashtable_policy.h:454
std::unordered_multiset::erase
iterator erase(const_iterator __first, const_iterator __last)
Erases a [__first,__last) range of elements from an unordered_multiset.
Definition: unordered_set.h:1185
std::unordered_multiset::erase
iterator erase(iterator __position)
Erases an element from an unordered_multiset.
Definition: unordered_set.h:1147
std::unordered_multiset::swap
void swap(unordered_multiset &__x) noexcept(noexcept(_M_h.swap(__x._M_h)))
Swaps data with another unordered_multiset.
Definition: unordered_set.h:1209
std::unordered_set::bucket_count
size_type bucket_count() const noexcept
Returns the number of buckets of the unordered_set.
Definition: unordered_set.h:628
std::unordered_set::begin
local_iterator begin(size_type __n)
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_set.h:662
std::unordered_set::hasher
_Hashtable::hasher hasher
Public typedefs.
Definition: unordered_set.h:104
std::unordered_multiset::insert
void insert(_InputIterator __first, _InputIterator __last)
A template function that inserts a range of elements.
Definition: unordered_set.h:1112
std::unordered_multiset::find
iterator find(const key_type &__x)
Tries to locate an element in an unordered_multiset.
Definition: unordered_set.h:1242
std::unordered_multiset
A standard container composed of equivalent keys (possibly containing multiple of each key value) in ...
Definition: unordered_set.h:767
std::unordered_set::emplace_hint
iterator emplace_hint(const_iterator __pos, _Args &&... __args)
Attempts to insert an element into the unordered_set.
Definition: unordered_set.h:394
std::unordered_set::empty
bool empty() const noexcept
Returns true if the unordered_set is empty.
Definition: unordered_set.h:290
std::unordered_set::operator=
unordered_set & operator=(const unordered_set &)=default
Copy assignment operator.
std::unordered_set::swap
void swap(unordered_set &__x) noexcept(noexcept(_M_h.swap(__x._M_h)))
Swaps data with another unordered_set.
Definition: unordered_set.h:552
std::unordered_set::end
local_iterator end(size_type __n)
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_set.h:682
std::unordered_set::insert
iterator insert(const_iterator __hint, const value_type &__x)
Attempts to insert an element into the unordered_set.
Definition: unordered_set.h:441
std::unordered_set::hash_function
hasher hash_function() const
Returns the hash functor object with which the unordered_set was constructed.
Definition: unordered_set.h:561
std::unordered_set::find
iterator find(const key_type &__x)
Tries to locate an element in an unordered_set.
Definition: unordered_set.h:585
std::unordered_set::rehash
void rehash(size_type __n)
May rehash the unordered_set.
Definition: unordered_set.h:723
std::unordered_set::equal_range
std::pair< const_iterator, const_iterator > equal_range(const key_type &__x) const
Finds a subsequence matching given key.
Definition: unordered_set.h:620
std::unordered_set::begin
const_iterator begin() const noexcept
Definition: unordered_set.h:315
std::unordered_multiset::iterator
_Hashtable::iterator iterator
Iterator-related typedefs.
Definition: unordered_set.h:789
std::unordered_multiset::operator=
unordered_multiset & operator=(initializer_list< value_type > __l)
Unordered_multiset list assignment operator.
Definition: unordered_set.h:948
std
ISO C++ entities toplevel namespace is std.
std::unordered_set::unordered_set
unordered_set(_InputIterator __first, _InputIterator __last, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_set from a range.
Definition: unordered_set.h:157
std::unordered_multiset::erase
size_type erase(const key_type &__x)
Erases elements according to the provided key.
Definition: unordered_set.h:1165
std::hash
Primary class template hash.
Definition: system_error:134
std::unordered_multiset::insert
iterator insert(const_iterator __hint, value_type &&__x)
Inserts an element into the unordered_multiset.
Definition: unordered_set.h:1098
std::unordered_multiset::size
size_type size() const noexcept
Returns the size of the unordered_multiset.
Definition: unordered_set.h:969
std::unordered_set::erase
size_type erase(const key_type &__x)
Erases elements according to the provided key.
Definition: unordered_set.h:511
std::unordered_set::end
const_iterator end() const noexcept
Definition: unordered_set.h:329
std::pair
Struct holding two objects of arbitrary type.
Definition: stl_pair.h:204
std::unordered_multiset::bucket_count
size_type bucket_count() const noexcept
Returns the number of buckets of the unordered_multiset.
Definition: unordered_set.h:1279
std::unordered_multiset::insert
void insert(initializer_list< value_type > __l)
Inserts a list of elements into the unordered_multiset.
Definition: unordered_set.h:1123
std::unordered_set::cend
const_local_iterator cend(size_type __n) const
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_set.h:690
std::unordered_set::operator=
unordered_set & operator=(initializer_list< value_type > __l)
Unordered_set list assignment operator.
Definition: unordered_set.h:274
std::unordered_set::begin
iterator begin() noexcept
Definition: unordered_set.h:311
std::unordered_multiset::difference_type
_Hashtable::difference_type difference_type
Iterator-related typedefs.
Definition: unordered_set.h:794
std::unordered_set::insert
std::pair< iterator, bool > insert(value_type &&__x)
Attempts to insert an element into the unordered_set.
Definition: unordered_set.h:416
std::unordered_multiset::insert
iterator insert(const value_type &__x)
Inserts an element into the unordered_multiset.
Definition: unordered_set.h:1068
std::unordered_multiset::rehash
void rehash(size_type __n)
May rehash the unordered_multiset.
Definition: unordered_set.h:1374
std::unordered_set::emplace
std::pair< iterator, bool > emplace(_Args &&... __args)
Attempts to build and insert an element into the unordered_set.
Definition: unordered_set.h:368
std::__detail::_Mod_range_hashing
Default range hashing function: use division to fold a large number into the range [0...
Definition: hashtable_policy.h:437
std::unordered_multiset::const_local_iterator
_Hashtable::const_local_iterator const_local_iterator
Iterator-related typedefs.
Definition: unordered_set.h:792
std::unordered_multiset::hash_function
hasher hash_function() const
Returns the hash functor object with which the unordered_multiset was constructed.
Definition: unordered_set.h:1218
std::unordered_multiset::emplace_hint
iterator emplace_hint(const_iterator __pos, _Args &&... __args)
Inserts an element into the unordered_multiset.
Definition: unordered_set.h:1056
std::unordered_multiset::hasher
_Hashtable::hasher hasher
Public typedefs.
Definition: unordered_set.h:778
std::unordered_set::insert
void insert(initializer_list< value_type > __l)
Attempts to insert a list of elements into the unordered_set.
Definition: unordered_set.h:471
std::unordered_multiset::max_size
size_type max_size() const noexcept
Returns the maximum size of the unordered_multiset.
Definition: unordered_set.h:974
std::unordered_multiset::const_iterator
_Hashtable::const_iterator const_iterator
Iterator-related typedefs.
Definition: unordered_set.h:790
std::unordered_set::equal_range
std::pair< iterator, iterator > equal_range(const key_type &__x)
Finds a subsequence matching given key.
Definition: unordered_set.h:616
std::unordered_set
A standard container composed of unique keys (containing at most one of each key value) in which the ...
Definition: unordered_set.h:93
std::unordered_set::cbegin
const_local_iterator cbegin(size_type __n) const
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_set.h:670
std::unordered_multiset::const_reference
_Hashtable::const_reference const_reference
Iterator-related typedefs.
Definition: unordered_set.h:788
std::unordered_multiset::end
local_iterator end(size_type __n)
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_set.h:1333
std::unordered_multiset::max_load_factor
void max_load_factor(float __z)
Change the unordered_multiset maximum load factor.
Definition: unordered_set.h:1363
std::unordered_multiset::key_type
_Hashtable::key_type key_type
Public typedefs.
Definition: unordered_set.h:776